#include <rpc/rpc.h>
#include <powerrpc.h>
#define RPC_CLIENT
#include "msg.h"
#undef _RPCAPI
#define _RPCAPI MSGSERVAPI
#define MSGSERVAPI __declspec(dllexport)
#define RPC_MT_CONNECT 1
#define RPC_RETURN_ARG 1
/******************************************
The two macros below show how to use fixed port
for server, and how to bypass portmapper
 registration
*******************************************/
#define MSGSERV_V1_tcp_server_port 2244

/* Default timeout can be changed using clnt_control() */
static struct timeval PWRPC_TIMEOUT_DEF = { 25, 0 };

#if !defined(RPC_RETURN_ARG)
char **
sendmsg_1(char **inarg_ptr,  CLIENT *clnt)
#else
int sendmsg_1(char **inarg_ptr, char **result_ptr,  CLIENT *clnt)
#endif
{

#ifndef RPC_RETURN_ARG

#ifdef PWRPC_MT
	_declspec(thread)
#endif
	static char *res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, sendmsg, (xdrproc_t)xdr_wrapstring, inarg_ptr, (xdrproc_t)xdr_wrapstring, &res, PWRPC_TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
#else

	bzero((char *)result_ptr, sizeof(*result_ptr));
	return clnt_call(clnt, sendmsg, (xdrproc_t)xdr_wrapstring, inarg_ptr, (xdrproc_t)xdr_wrapstring, result_ptr, PWRPC_TIMEOUT);
#endif

}


#if !defined(RPC_RETURN_ARG)
int *
sendintegers_1(int *inarg_ptr,  CLIENT *clnt)
#else
int sendintegers_1(int *inarg_ptr, intarr result_ptr,  CLIENT *clnt)
#endif
{

#ifndef RPC_RETURN_ARG

#ifdef PWRPC_MT
	_declspec(thread)
#endif
	static intarr res;

	bzero((char *)res, sizeof(res));
	if (clnt_call(clnt, sendintegers, (xdrproc_t)xdr_intarr, inarg_ptr, (xdrproc_t)xdr_intarr, res, PWRPC_TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (res);
#else

	bzero((char *)result_ptr, sizeof(result_ptr));
	return clnt_call(clnt, sendintegers, (xdrproc_t)xdr_intarr, inarg_ptr, (xdrproc_t)xdr_intarr, result_ptr, PWRPC_TIMEOUT);
#endif

}


#if !defined(RPC_RETURN_ARG)
int *
send_double_1(double *inarg_ptr,  CLIENT *clnt)
#else
int send_double_1(double *inarg_ptr, int *result_ptr,  CLIENT *clnt)
#endif
{

#ifndef RPC_RETURN_ARG

#ifdef PWRPC_MT
	_declspec(thread)
#endif
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, send_double, (xdrproc_t)xdr_double, inarg_ptr, (xdrproc_t)xdr_int, &res, PWRPC_TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
#else

	bzero((char *)result_ptr, sizeof(*result_ptr));
	return clnt_call(clnt, send_double, (xdrproc_t)xdr_double, inarg_ptr, (xdrproc_t)xdr_int, result_ptr, PWRPC_TIMEOUT);
#endif

}

