#include <stdio.h>
#include <rpc/rpc.h>
#include "quote.h"

void print_stk(quoteRec*pq) {
	if(!pq) return;
	printf("\nResult: company=%s bid=%4.2f ask=%4.2f vol=%d tr=%c\n",
		          pq->company_name, pq->bid, pq->ask, pq->volume, pq->trend);
	if(pq->prof) {
			printf("Profile: pe=%f mkt_cap=%f\n", pq->prof->pe, pq->prof->mkt_cap);
	}
}


main(argc, argv)
int argc;
char *argv[];
{
	CLIENT *cl;
	int i, val;
	struct stockOrder order;
	struct quoteRec *pq=0;
	char tick[12];
	char *pt = tick;
	int len=0;
	
	cl = clnt_create("localhost", quote, quote_v1, "udp");
	
	if (cl == NULL) {
		clnt_pcreateerror(argv[1]);
		exit (1);
	}

	
	while(1) {
		printf("\nEnter ticker\n==>");
		scanf("%s", tick);
		tick[7]='\0';

		/* Call rpc here */

		pq = get_quote_2(&pt,cl); 

		
		print_stk(pq);

		len = xdr_sizeof(xdr_quoteRec, (void*)pq); 
		printf("XDR_SIZEOF returned %d\n", len);

		xdr_free(xdr_quoteRec, (char*)pq); /*pq->company_name is allocated by RPC */

		strcpy(order.tick, tick);
		order.quantity = 100;
		order.trade_type='S';

       // val = *trade_2(&order,cl); /* RPC */
		//printf("Trade %d shares", val);

		pq = * ping_2((void*)0,cl);
		printf (" Ping got %d \n", (u_long) pq);
		print_stk(pq);
	
	}
	
	clnt_destroy(cl);
	return 0;
}


