#include <stdio.h>
#include <rpc/rpc.h>
#include <rpc/pmap_cln.h>
#define _RPC_SERVER
#include "quote.h"
#include <powerrpc.h>
static SVCXPRT *tcp_master =0;
static SVCXPRT *udp_master =0;
#define PWRPC_MT_ON_CALL PWRPC_ONC_MT

static void
quote_2(rqstp, transp)
	struct svc_req *rqstp;
	SVCXPRT *transp;
{
	union {
		char *get_quote_2_OVER;
		stockOrder trade_2_OVER;
	} RPC_over;
	union {
		quoteRec get_quote_2_BACK;
		int trade_2_BACK;
		pRec ping_2_BACK;
	} RPC_back;
	pwrpc_call_struct callInfo;
	callInfo.ptransport = transp;
	callInfo.pover = (caddr_t)&RPC_over;
	callInfo.pback = (caddr_t)&RPC_back;
	callInfo.reply_now = 0;
#ifndef PWRPC_MT_ON_CALL
#define PWRPC_MT_ON_CALL 5
#endif
	callInfo.mt_on_call = PWRPC_MT_ON_CALL;
	callInfo.free_after = 0;
	callInfo.proc = 0;
	callInfo.psvc_req = rqstp;

	switch (rqstp->rq_proc) {
	case NULLPROC:
		(void)svc_sendreply(transp, xdr_void, (char *)NULL);
		return;

	case get_quote:
		callInfo.xdr_over = (xdrproc_t) xdr_wrapstring;
		callInfo.over_size = sizeof(RPC_over);
		callInfo.xdr_back = (xdrproc_t)xdr_quoteRec;
		callInfo.back_size = sizeof(RPC_back);
		callInfo.local = (local_call_t) get_quote_2_svc;
		break;

	case trade:
		callInfo.xdr_over = (xdrproc_t) xdr_stockOrder;
		callInfo.over_size = sizeof(RPC_over);
		callInfo.xdr_back = (xdrproc_t)xdr_int;
		callInfo.back_size = sizeof(RPC_back);
		callInfo.local = (local_call_t) trade_2_svc;
		break;

	case ping:
		callInfo.xdr_over = (xdrproc_t) xdr_void;
		callInfo.over_size = sizeof(RPC_over);
		callInfo.xdr_back = (xdrproc_t)xdr_pRec;
		callInfo.back_size = sizeof(RPC_back);
		callInfo.local = (local_call_t) ping_2_svc;
		break;

	default:
		svcerr_noproc(transp);
		return;
	}
	pw_serv_call(&callInfo);

}



main()
{
	SVCXPRT *transp;

	pw_serv_init();
	(void)pmap_unset(quote, quote_v1);

#ifndef RPC_MT_CONNECT
#define RPC_MT_CONNECT 0
#endif
	pw_set_mt_on_connect(RPC_MT_CONNECT);
	transp = svcudp_create(RPC_ANYSOCK);
	if (transp == NULL) {
		(void)fprintf(stderr, "cannot create udp service.\n");
		exit(1);
	}
		(void)fprintf(stdout, "Created udp service.\n");
	udp_master = transp;
	if (!svc_register(transp, quote, quote_v1, quote_2, IPPROTO_UDP)) {
		(void)fprintf(stderr, "unable to register (quote, quote_v1, udp).\n");
		exit(1);
	}

#ifndef RPC_MT_CONNECT
#define RPC_MT_CONNECT 0
#endif
	pw_set_mt_on_connect(RPC_MT_CONNECT);
	transp = svctcp_create(RPC_ANYSOCK, 0, 0);
	if (transp == NULL) {
		(void)fprintf(stderr, "cannot create tcp service.\n");
		exit(1);
	}
		(void)fprintf(stdout, "Created tcp service.\n");
	tcp_master = transp;
	if (!svc_register(transp, quote, quote_v1, quote_2, IPPROTO_TCP)) {
		(void)fprintf(stderr, "unable to register (quote, quote_v1, tcp).\n");
		exit(1);
	}
	pw_serv_mainloop(tcp_master, udp_master, 0, 1);
	(void)fprintf(stderr, "svc_run returned\n");
	exit(1);return 0;
}
