/* License: @%%Netbula RPC Time Limited Demo, Commercial Distribution Prohibited! */

#ifndef types_h
#define types_h

#ifdef __cplusplus
extern "C" {
#endif
#include <rpc/types.h>

/*redefine below to use different timeout*/
#ifndef PWRPC_TIMEOUT
#define PWRPC_TIMEOUT PWRPC_TIMEOUT_DEF
#endif

#ifndef _RPCAPI
#define _RPCAPI  /* wanna change this? */
#endif


#ifdef _RPC_SERVER
#define server_err(x) pwrpc_report_event(x)
#define server_msg(x) pwrpc_report_event(x)
#define server_exit(x) exit(x)
#endif

#define INT 1
#define TS 2

struct quote {
	int v1;
	int v2;
};
typedef struct quote quote;

#if !(defined(__cplusplus) || defined(__STDC__))
bool_t xdr_quote();
#else
bool_t xdr_quote(XDR*, quote*);
#endif


enum NUM {
	ONE = 1,
	TWO = 2,
};
typedef enum NUM NUM;

#if !(defined(__cplusplus) || defined(__STDC__))
bool_t xdr_NUM();
#else
bool_t xdr_NUM(XDR*, NUM*);
#endif


struct un {
	int which;
	union {
		int iv;
		struct quote q;
	} un_u;
};
typedef struct un un;

#if !(defined(__cplusplus) || defined(__STDC__))
bool_t xdr_un();
#else
bool_t xdr_un(XDR*, un*);
#endif


struct un2 {
	NUM which;
	union {
		int iv;
		struct quote q;
	} un2_u;
};
typedef struct un2 un2;

#if !(defined(__cplusplus) || defined(__STDC__))
bool_t xdr_un2();
#else
bool_t xdr_un2(XDR*, un2*);
#endif


struct type_st {
	char c;
	short s;
	int i;
	long l;
	u_long h;
	float f;
	double d;
	struct {
		u_int o_len;
		char *o_val;
	} o;
	enum NUM num;
	int *pi;
	struct {
		u_int i_var_arr_len;
		int *i_var_arr_val;
	} i_var_arr;
	int i_arr[10];
	struct type_st *pst;
	struct {
		u_int qarr_len;
		struct quote *qarr_val;
	} qarr;
	struct quote qarr2[TS];
	un v3;
};
typedef struct type_st type_st;

#if !(defined(__cplusplus) || defined(__STDC__))
bool_t xdr_type_st();
#else
bool_t xdr_type_st(XDR*, type_st*);
#endif


typedef type_st types;

#if !(defined(__cplusplus) || defined(__STDC__))
bool_t xdr_types();
#else
bool_t xdr_types(XDR*, types*);
#endif


#define type_test ((u_long)5252522)
#define v_1 ((u_long)1)
#define inc ((u_long)1)

#if !(defined(RPC_RETURN_ARG) && defined(RPC_CLIENT))
_RPCAPI extern types*
#else
_RPCAPI extern int
#endif
#ifndef __cplusplus
inc_1();
#else
inc_1(...); /*generated client stub*/
#endif


#if !defined(RPC_CLIENT)
_RPCAPI extern types*
#if !(defined(__cplusplus) || defined(__STDC__))
inc_1_svc(); /*service routine to be implemented*/
#else
inc_1_svc(types *, struct svc_req *rqstp); /*Programmer implements this for server */
#endif
#endif
#define dec ((u_long)2)

#if !(defined(RPC_RETURN_ARG) && defined(RPC_CLIENT))
_RPCAPI extern types*
#else
_RPCAPI extern int
#endif
#ifndef __cplusplus
dec_1();
#else
dec_1(...); /*generated client stub*/
#endif


#if !defined(RPC_CLIENT)
_RPCAPI extern types*
#if !(defined(__cplusplus) || defined(__STDC__))
dec_1_svc(); /*service routine to be implemented*/
#else
dec_1_svc(types *, struct svc_req *rqstp); /*Programmer implements this for server */
#endif
#endif

#ifdef __cplusplus
};
#endif


#endif
