#include <rpc/rpc.h>
#include "quote.h"
#define PWRPC_MT_ON_CALL PWRPC_ONC_MT


bool_t
xdr_quoteRec(xdrs, objp)
	XDR *xdrs;
	quoteRec *objp;
{
	if (!xdr_string(xdrs, &objp->company_name, MAXLEN)) {
		return (FALSE);
	}
	if (!xdr_double(xdrs, &objp->bid)) {
		return (FALSE);
	}
	if (!xdr_double(xdrs, &objp->ask)) {
		return (FALSE);
	}
	if (!xdr_u_long(xdrs, &objp->volume)) {
		return (FALSE);
	}
	if (!xdr_char(xdrs, &objp->trend)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_stockOrder(xdrs, objp)
	XDR *xdrs;
	stockOrder *objp;
{
	if (!xdr_vector(xdrs, (char *)objp->tick, 8, sizeof(char), xdr_char)) {
		return (FALSE);
	}
	if (!xdr_char(xdrs, &objp->trade_type)) {
		return (FALSE);
	}
	if (!xdr_u_long(xdrs, &objp->quantity)) {
		return (FALSE);
	}
	return (TRUE);
}


